﻿Imports Microsoft.VisualBasic.FileIO

Public Class Form1

    Private Sub btnLerCSV_Click(sender As Object, e As EventArgs) Handles btnLerCSV.Click

        If String.IsNullOrWhiteSpace(txtArquivoCSV.Text) Then
            MessageBox.Show("Informe o caminho e nome do arquivo Texto...")
            Return
        Else

            Using leitorArquivoCSV As New TextFieldParser(txtArquivoCSV.Text)

                'define o tipo de arquivo como delimitado
                leitorArquivoCSV.TextFieldType = FileIO.FieldType.FixedWidth
                'define o delimitador usado no arquivo
                leitorArquivoCSV.SetDelimiters(",")
                'Define o caractere que indica que a linha é um comentário
                leitorArquivoCSV.CommentTokens = New String() {"#"}
                ''Informe que existe um campo que esta envolto em aspas duplas (")
                leitorArquivoCSV.HasFieldsEnclosedInQuotes = True

                'define um array de string
                Dim linhaAtual As String()

                'pula a primeira linha do arquivo 
                leitorArquivoCSV.ReadLine()

                'inicia o laço para iterar no arquivo texto
                While Not leitorArquivoCSV.EndOfData

                    Try
                        'le uma linha do arquivo
                        linhaAtual = leitorArquivoCSV.ReadFields()
                        Dim campoAtual As String
                        'le cada campo delimitado no arquivo e atribui ao TextBox
                        For Each campoAtual In linhaAtual
                            txtDados.Text += campoAtual
                        Next
                        'define uma  nova linha no TextBox que exibe os dados
                        txtDados.Text += vbCrLf
                    Catch ex As MalformedLineException
                        MsgBox("A linha  " & ex.Message & " não é valida e será descartada.")
                    End Try

                End While

            End Using
        End If
    End Sub
End Class
